# Tunneled BWT Threshold test
Experiments for threshold testing of our new heuristic

## What is contained
This bundle of files consist of the following parts:
1. A program measuring compression depending on the threshold
2. A set of test files (which need to be downloaded first, see below), contained
   in the `rcrdata`-directory

## Requirements
To run the benchmark, you need the following:
- a modern c++11 ready compiler such as [gcc](https://gcc.gnu.org/) version 4.7 or newer
- [awk]

To download and set up the test files, the following programs are needed:
- [curl](https://curl.haxx.se/)
- [gzip]
- [bzip2]

## Installation
- To download the test data, switch into the `rcrdata` - directory, and call `make`.
  This will download and extract all of the test data using [curl].

## Usage

### Benchmark
To run the benchmark, configure the file `testcases.config`
as you require it, an example is already listed. Afterwards, call

	make

After the benchmark has finished, a file named `thresholdcompressibility.csv` is generated:
It is a csv file containing for each BWT of a tested file the amount of characters (n),
the number of runs (r), the number of runs with height greater 1 (rg1), the number of
run-length characters (rc), as well as the compressed size in bytes depending on the
threshold (0-50).

### Replicating Computational Results
The most straightforward way to use this benchmark is by just calling

	make rcr

This command will automatically download the test data, sets up the benchmark
properly (Warning: the testcases.config - file will be overwritten), execute the
benchmark and generate all resulting files. Your machine should contain 16 GB
of memory to ensure no swapping takes place.
